=== debian/changelog ===
cp2k (2.6.2-3) unstable; urgency=medium

  * debian/patches/makeflags.patch: Switch to ELPA2.
  * debian/control (Build-Depends): Bump libelpa-dev to 2015.05.001.
  * debian/control (Build-Depends): Tighten libelpa-dev version to -3 where the
    modules are installed at the usual location again (Closes: #816086).

 -- Michael Banck <mbanck@debian.org>  Sat, 27 Feb 2016 19:06:01 +0100

cp2k (2.6.2-2) unstable; urgency=medium

  * debian/patches/elpa2_support.patch: New patch to support ELPA2 interface,
    taken from upstream revisions 15202 and 15213.
  * debian/patches/makeflags.patch: Updated for openmpi-1.10, thanks to
    Alastair McKinstry (Closes: #813799).
  * debian/control (Build-Depends): Added pkg-config.

 -- Michael Banck <mbanck@debian.org>  Sun, 07 Feb 2016 13:05:29 +0100

cp2k (2.6.2-1) unstable; urgency=medium
 
  * New upstream point release.

 -- Michael Banck <mbanck@debian.org>  Sun, 22 Nov 2015 19:07:47 +0100
