=== debian/changelog ===
cp2k (3.0.0-1build1) zesty; urgency=medium

  * No-change rebuild against libopenmpi2

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sat, 22 Oct 2016 01:23:06 +0000

cp2k (3.0.0-1) unstable; urgency=medium

  * New upstream release, new features include:
    + K-points for GGA DFT
    + Unrestricted MP2 gradients
    + Implicit Poisson solver, with dielectric, and different boundary
      conditions
    + Improvements in the path integral code, including the PIGLET thermostat
    + G0W0 and eigenvalue self-consistent GW
    + Filtered basis method
    + Polarized atomic orbitals
  * debian/patches/testsuite_output.patch: Refreshed.
  * debian/patches/elpa2_support.patch: Removed, no longer needed.
  * debian/patches/data_files_standard_location.patch: Likewise.
  * debian/control (Build-Depends): Bump libelpa-dev dependency to
    2016.05.001-1.
  * debian/patches/makeflags.patch: Update ELPA define to __ELPA3.
  * debian/patches/makeflags.patch: Add /usr/include to include path for
    LibXC's Fortran90 modules.
  * debian/patches/makeflags.patch: Add LibXC's Fortran90 to LIBS.
  * debian/patches/libxc3_support.patch: New patch, conditionalize XC
    functional names according to major version.
  * debian/control (Build-Depends): Bump libxc-dev dependency to
    3.0.0-1.
  * debian/cp2k.examples: Replaced no longer present He-ri.inp example with
    H2O-hfx-1.inp.
  * debian/rules (override_dh_auto_test): Update list of regression test
    directories.
  * debian/regtest.config: Add numprocs=1 to regression tester config.

 -- Michael Banck <mbanck@debian.org>  Sun, 29 May 2016 16:21:00 +0200
