=== debian/control ===
--- 
+++ 
@@ -1,7 +1,8 @@
 Source: cp2k
 Section: science
 Priority: optional
-Maintainer: Debichem Team <debichem-devel@lists.alioth.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debichem Team <debichem-devel@lists.alioth.debian.org>
 Uploaders: Michael Banck <mbanck@debian.org>
 Build-Depends: bc,
                bison,
@@ -11,13 +12,13 @@
                python, 
                gfortran,
                libblas-dev,
-               libelpa-dev (>= 2015.05.001-3),
+               libelpa-dev (>= 2016.05.001-1),
                libfftw3-dev,
                libint-dev,
                liblapack-dev,
                libsaxonb-java,
                libscalapack-mpi-dev,
-               libxc-dev,
+               libxc-dev (>= 3.0.0-1),
                mpi-default-dev,
 	       pkg-config
 Standards-Version: 3.9.4
