=== debian/changelog ===
cp2k (4.1-1) unstable; urgency=medium

  * New upstream release, new features include:
    + Cubic-scaling RPA
    + Maximum Overlap Method (MOM)
    + Polarized Atomic Orbitals from Machine Learning (PAO-ML)
    + Modified Atomic Orbitals (MAO) Analysis
    + Improved linear scaling (LS) DFT MD with curvy steps
    + GTH-PBE pseudopotentials for the Lanthanide elements
    + Fast method for periodic ERI reducing overhead of image charge correction
      in QM/MM and used in cubic-scaling RPA
    + Additional collective variables
  * debian/patches/libxc3_support.patch: Refreshed.
  * debian/rules (override_dh_auto_test): No longer symlink in testresults.
  * debian/patches/makeflags.patch: Updated, DATA_DIR is now a top-level
    variable.
  * debian/rules (CP2K_DATA_DIR): New variable, overrides DATA_DIR to the local
    directory for the testsuite.
 
 -- Michael Banck <mbanck@debian.org>  Wed, 05 Oct 2016 23:49:21 +0200
